""" defworld.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

from world import world
from know import know
from task import task
from thing import thing
from mind import mind
from event import *
import wtime,mgoal

#There is mailing list for developers:
#cyphesis-devel@lists.1ststep.net

#This list is intended for discussion about development of cyphesis.
#General discussion should go to cyphesis@lists.1ststep.net -list.

#To subscribe send message to cyphesis-devel-request@lists.1ststep.net
#with text "subscribe" in the body of message.

#This list doesn't include cyphesis-snapshot
#To subscribe to cyphesis-snapashot send message to 
#cyphesis-snapshot-request@lists.1ststep.net
#with text "subscribe" in the body of message.

def default():
    #general things
    w=world()

    human_goals=[mgoal.find_home]

    human_knowledge=know()
    human_knowledge.add('place','axe','smithy')

    village_height=300
    village_knowledge=know()
    village_knowledge.add('xyz','smithy',(20,10,village_height+5))
    village_knowledge.add('xyz','forest',(150,-50,village_height-50))

    peasant_tasks=[
        task('have a breakfast', 'morning', 'home'),
        task('have a dinner', 'midday', 'home'),
        task('have a supper', 'evening', 'home'),
        task('sleep good night', 'night', 'home')]

    class cut(task):
        def do(self, info):
            return [event("cut",what=info.objects[self.objects[0]])]

    class make_axe(task):
        def do(self, info):
            return [event("make",what="axe", what_desc="ordinary axe")]

    class home(thing):
        def __init__(self):
            thing.__init__(self,'house','ordinary house','home')

    #farmer
    t=thing('axe','normal axe good for cutting trees','forest',1.0)
    h=home()
    farmer_knowledge=know()
    farmer_knowledge.add('xyz','home',(20,50,village_height))
    farmer_knowledge.add('xyz','field',(-100,50,village_height))
    farmer=mind('farmer','ordinary farmer','home',peasant_tasks,
                age=wtime.years(21),
                personal_knowledge=farmer_knowledge,
                local_knowledge=village_knowledge,
                common_knowledge=human_knowledge,
                common_goals=human_goals,
                things=[t,h])
    farmer.add_task(task('sow field', 'spring', 'field'))
    farmer.add_task(task('tend fields', 'summer', 'field'))
    farmer.add_task(task('harvest crop', 'autumn', 'field'))
    farmer.add_task(cut('chop trees', 'winter', 'forest',['axe']))
    w.add_mind(farmer)
    w.add_thing(t)
    w.add_thing(h)

    #smith
    h=home()
    smithy=thing('smithy','ordinary smithy','smithy')
    smith=mind('smith','only smith in village','home',peasant_tasks,
               age=wtime.years(30),
               personal_knowledge=know(xyz={'home':(70,0,village_height)}),
               local_knowledge=village_knowledge,
               common_knowledge=human_knowledge,
               common_goals=human_goals,
               things=[h,smithy])
    smith.add_task(make_axe('forge tools', 'always','smithy'))
    w.add_mind(smith)
    w.add_thing(h)
    w.add_thing(smithy)
    return w
