""" event.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

------------------------------------------------------------

ething(id,name="foo",type="thing.mind")
event("look",what=ething(id,name="foo",type="thing.mind"))
event("say",what=esay(?,?))

world.py:
 event('look',what=t.id,source=t.get_xyz())
 event("move",event_source=m, what=e.what,source=e.what.place, target=target)
 event("destroy", event_source=m, what=t)
 event("make", event_source=m, what=t)
 event("say", event_source=m, what=e.what, source=m)
 event("make", desc="birth", event_source=self, what=mnew)
 event("destroy", desc="death", event_source=self, what=m)
 event("fire", event_source=self, what=f, target=t)
mind.py:
 event("NYI",desc="Try another task!")
 event("extinguish",what=self, target=e.what)
mgoal.py:
 event("make",what="house", what_desc="home", target=self.get_xyz())
observe.py:
 event('look',what='all')
 event('load',what='default')
 event('step')
"""

import string

class event_base:
    def strv(self, var):
        value=self.__dict__[var]
        if value: return self.l.append(" "+var+": "+str(value))
        else: return ""
    def reprv(self, var):
        value=self.__dict__[var]
        if value: self.l.append(var+"="+`value`)
    def __str__(self):
        name=self.__class__.__name__
        var_list=self.var_list
        if len(var_list)==0: return name+"()"
        elif len(var_list)==1: return name+"("+str(getattr(self,var_list[0]))+")"
        self.l=[]
        for var in var_list[1:]:
            self.strv(var)
        return "<"+name+"("+str(getattr(self,var_list[0]))+\
               ","+string.join(self.l,",")+")>\n"
    def __repr__(self):
        name=self.__class__.__name__
        var_list=self.var_list
        if len(var_list)==0: return name+"()"
        elif len(var_list)==1: return name+"("+`getattr(self,var_list[0])`+")"
        self.l=[]
        for var in var_list[1:]:
            self.reprv(var)
        return name+"("+`getattr(self,var_list[0])`+","+string.join(self.l,",")+")"

class event(event_base):
    #__dict__ doesn't define order
    var_list=["command", "event_source", "desc", "what", "what_desc", 
              "loc", "loc_desc"]
    def __init__(self, command, event_source=None, desc=None,
                 what=None, what_desc=None,
                 loc=None, loc_desc=None):
        self.command=command
        self.event_source=event_source
        self.desc=desc
        self.what=what
        self.what_desc=what_desc
        self.loc=loc
        self.loc_desc=loc_desc

class ething(event_base):
    var_list=["id", "name", "type"]
    def __init__(self, id, name=None, type=None):
        self.id=id
        self.name=name
        self.type=type

def get_event_func(self,e):
    c=e.command+"_event"
    try:
        func=self.event_dict[c]
    except KeyError:
        try:
            func=self.event_dict[c]=getattr(self,c)
        except AttributeError:
            func=self.event_dict[c]=self.undefined_event
    return func
