""" task.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

import wtime
from event import *

class task_info:
    "task info class: things that change per real individual task"
    def __init__(self, task, objects={}):
        if not objects and task:
            self.objects={}
            for o in task.objects: self.objects[o]=None
        else: self.objects=objects.copy()

class task:
    "task class"
    def __init__(self, desc='some task', time, place, objects=[], importance=None):
        self.__doc__=desc
        self.time=time
        self.place=place
        self.objects=objects[:]
        self.importance=wtime.time2importance(time)
    def __str__(self):
        s="<Task: description: "+self.__doc__
        s=s+", time: "+`self.time`
        s=s+", place: "+`self.place`
        s=s+", importance: "+`self.importance`
        s=s+", objects: "+`self.objects`
        return s+">\n"
    def __repr__(self):
        return "<Task: "+self.__doc__+"> "
    def do(self, info=None):
        return [event("imaginary",desc=self.__doc__)]
