""" thing.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

from copy import copy
import util

class thing:
    "thing: (=base class npc,tools, etc)"
    def __init__(self, name, desc='some thing', place='home', status=1.0,
                 age=0.0, xyz=None):
        self.name=name
        self.__doc__=desc
        self.place=place
        self.status=status
        self.age=age #in seconds
        self.xyz=xyz #coordinates
        self.id=self.name
    def destroy(self): pass
    def str(self):
        s="name: "+str(self.name)
        s=s+", id: "+str(self.id)
        s=s+", description: "+str(self.__doc__)
        s=s+", place: "+str(self.place)
        s=s+", xyz: "+str(self.xyz)
        s=s+", status: "+str(self.status)
        s=s+", age: "+str(self.age)
        return s
    def __str__(self):
        return "<Thing: "+self.str()+">\n"
    def __repr__(self):
        return `self.id`
    def get_xyz(self):
        try:
            return self.place.get_xyz()
        except AttributeError:
            return self.xyz
    def get_loc(self):
        if self.xyz: return self.xyz
        return self.place
    def get_type(self):
        return util.get_derivation_string(self.__class__)
